CHIPMEMSIZE=$80000
FASTMEMSIZE=$80000
FAKEFMEMSIZE=0
MAJOR_VERSION = 1
MINOR_VERSION = 4

	IFD	BARFLY
WHDLOADSLAVE = 1
	OUTPUT	LureOfTheTemptress.slave
	ENDC
	incdir	include:
	include	"jst.i"
	HD_PARAMS	"disk.",870912,4,<Lure Of The Temptress>,<1992 Revolution Software>,<Install & fix by JOTD>

; display custom variables (for hrtmon)
; $1FDCE in UK version

VER_GERMAN = 1
VER_FRENCH = 2
VER_ENGLISH = 3
VER_ENGLISH2 = 4
VER_ITALIAN = 5

DECRUNCH1_LEN = $368
DECRUNCH2_LEN = $288
SAVE_LEN = $11600

START_DECRUNCH1_GERMAN = $1F568
END_DECRUNCH1_GERMAN   = START_DECRUNCH1_GERMAN+DECRUNCH1_LEN

START_DECRUNCH2_GERMAN = $1F8D4
END_DECRUNCH2_GERMAN   = START_DECRUNCH2_GERMAN+DECRUNCH2_LEN

START_DECRUNCH1_FRENCH = $1F404
END_DECRUNCH1_FRENCH   = START_DECRUNCH1_FRENCH+DECRUNCH1_LEN

START_DECRUNCH2_FRENCH = $1F770
END_DECRUNCH2_FRENCH   = START_DECRUNCH2_FRENCH+DECRUNCH2_LEN

START_DECRUNCH1_ENGLISH = $1F762
END_DECRUNCH1_ENGLISH   = START_DECRUNCH1_ENGLISH+DECRUNCH1_LEN

START_DECRUNCH2_ENGLISH = $1F3F6
END_DECRUNCH2_ENGLISH   = START_DECRUNCH2_ENGLISH+DECRUNCH2_LEN

START_DECRUNCH1_ENGLISH2 = $1F708
END_DECRUNCH1_ENGLISH2   = START_DECRUNCH1_ENGLISH2+DECRUNCH1_LEN

START_DECRUNCH2_ENGLISH2 = $1F39C
END_DECRUNCH2_ENGLISH2   = START_DECRUNCH2_ENGLISH2+DECRUNCH2_LEN

START_DECRUNCH1_ITALIAN = $1F6F8
END_DECRUNCH1_ITALIAN   = START_DECRUNCH1_ITALIAN+DECRUNCH1_LEN

START_DECRUNCH2_ITALIAN = $1F38C
END_DECRUNCH2_ITALIAN   = START_DECRUNCH2_ITALIAN+DECRUNCH2_LEN


loader:
	RELOC_MOVEL	D4,buttonwait

	move.l	#$80000,D0
	JSRABS	AllocExtMem
	RELOC_MOVEL	D0,ExtBase
	beq	MemErr

	Mac_printf	"Lure of the Temptress HD Loader V1.2"
	Mac_printf	"Coded by Jean-Franois Fabre  1997"

	JSRABS	LoadDisks

	moveq.l	#0,D0
	move.l	#CACRF_CopyBack,D1
	JSRABS	Degrade

;	WAIT_LMB

	GO_SUPERVISOR
	SAVE_OSDATA	$80000

	bsr	installboot

	move.l	ExtBase(pc),$0.W

	; **** boot stuff and patch

	JSRGEN	FlushCachesHard

	JMP	$70058

PatchLoader1:
	move.l	D0,-(sp)
	move.l	buttonwait(pc),D0
	beq	.skip
.bw
	btst	#7,$BFE001
	beq	.skip
	btst	#6,$BFE001
	beq	.skip
	bra	.bw
.skip
	move.l	(sp)+,D0

	bsr	PatchAccessFault

	lea	version(pc),A0

	cmp.l	#'Date',$59F0.W
	beq	PatchGerman1


PatchFrench1:
	cmp.l	#'ichi',$59F0.W
	bne	PatchEnglish1

	move.l	#VER_FRENCH,(A0)

	; *** load routine - french

	PATCHUSRJMP	$3CBB4,ReadSectors2

	; *** copy protection

	move.l	#$42404E75,$19734

	; *** kb interrupt - french

	PATCHUSRJSR	$1FDC4,KbInt

	; *** HD saves - french

	; *** removes insert disk requester for load/save - french

	move.l	#$4E714E71,$1FFCE ; SAVE
	move.l	#$4E714E71,$20104	; LOAD

	; *** load and save - french

	PATCHUSRJMP	$19C54,SaveGameHD
	PATCHUSRJMP	$19C7E,LoadGameHD
	PATCHUSRJMP	$3CC38,SaveGameDir

	; *** $BFD100 routine - french

	move.l	#$70FF4E75,$3CD70

	; *** memory patch - french

	PATCHUSRJMP	$1FA3C,RelocateFrench

	; *** prevents floppy formatting - french

	move.l	#$7E004E75,$3CCCA

	; *** copies the decrunch1 routine in fast memory - french

	lea	START_DECRUNCH1_FRENCH,A0
	lea	END_DECRUNCH1_FRENCH,A2

	bsr	RelocDecrunch1

	PATCHUSRJMP	START_DECRUNCH1_FRENCH,FastDecrunch1

	; *** copies the decrunch2 routine in fast memory - french

	lea	START_DECRUNCH2_FRENCH,A0
	lea	END_DECRUNCH2_FRENCH,A2

	bsr	RelocDecrunch2

	PATCHUSRJMP	START_DECRUNCH2_FRENCH,FastDecrunch2


;	PATCHUSRJMP	$19C54,CopyDisk
	
	bra	PatchStart1

PatchStart1:
	; *** flush caches

	JSRGEN	FlushCachesHard
	jmp	$4000.W


PatchEnglish1:
	cmp.l	#'Info',$59F0.W
	bne	PatchEnglish2

	move.l	#VER_ENGLISH,(A0)

	; *** load routine - english

	PATCHUSRJMP	$3B278,ReadSectors2

	; *** copy protection

	move.l	#$42404E75,$19776

	; *** kb interrupt - english

	PATCHUSRJSR	$1FDB6,KbInt

	; *** memory patch - english

	PATCHUSRJMP	$1FA2E,RelocateEnglish

	; *** HD saves - english

	; *** removes insert disk requester for load/save - english

	move.l	#$4E714E71,$1FFC6	; SAVE
	move.l	#$4E714E71,$200FC	; LOAD

	; *** load and save - english

	PATCHUSRJMP	$19C96,SaveGameHD
	PATCHUSRJMP	$19CC0,LoadGameHD
	PATCHUSRJMP	$3B2FC,SaveGameDir

	; *** prevents floppy formatting

	move.l	#$7E004E75,$3B38E

	; *** removes a $BFD100 access routine

	move.l	#$70FF4E75,$3B434

	; *** copies the decrunch1 routine in fast memory - english

	lea	START_DECRUNCH1_ENGLISH,A0
	lea	END_DECRUNCH1_ENGLISH,A2

	bsr	RelocDecrunch1

	PATCHUSRJMP	START_DECRUNCH1_ENGLISH,FastDecrunch1


	; *** copies the decrunch2 routine in fast memory - english

	lea	START_DECRUNCH2_ENGLISH,A0
	lea	END_DECRUNCH2_ENGLISH,A2

	bsr	RelocDecrunch2

	PATCHUSRJMP	START_DECRUNCH2_ENGLISH,FastDecrunch2

	bra	PatchStart1

PatchEnglish2:
	cmp.l	#$696C65FF,$59F0.W	; "ile"+$FF
	bne	PatchItalian

	move.l	#VER_ENGLISH2,(A0)

	; *** load routine - english 2

	PATCHUSRJMP	$3B1A8,ReadSectors2

	; *** copy protection - english 2

	move.l	#$42404E75,$1971C

	; *** kb interrupt - english 2

	PATCHUSRJSR	$1FD5C,KbInt

	; *** memory patch - english 2

	PATCHUSRJMP	$1F9D4,RelocateEnglish2

	; *** HD saves - english 2

	; *** removes insert disk requester for load/save - english 2

	move.l	#$4E714E71,$1FF6C	; SAVE
	move.l	#$4E714E71,$200A2	; LOAD

	; *** load and save - english 2

	PATCHUSRJMP	$19C3C,SaveGameHD
	PATCHUSRJMP	$19C66,LoadGameHD
	PATCHUSRJMP	$3B22C,SaveGameDir

	; *** prevents floppy formatting

	move.l	#$7E004E75,$3B2BE

	; *** removes a $BFD100 access routine

	move.l	#$70004E75,$3B364

	; *** copies the decrunch1 routine in fast memory - english

	lea	START_DECRUNCH1_ENGLISH2,A0
	lea	END_DECRUNCH1_ENGLISH2,A2

	bsr	RelocDecrunch1

	PATCHUSRJMP	START_DECRUNCH1_ENGLISH2,FastDecrunch1


	; *** copies the decrunch2 routine in fast memory - english

	lea	START_DECRUNCH2_ENGLISH2,A0
	lea	END_DECRUNCH2_ENGLISH2,A2

	bsr	RelocDecrunch2

	PATCHUSRJMP	START_DECRUNCH2_ENGLISH2,FastDecrunch2

	bra	PatchStart1

PatchItalian:
	cmp.l	#'File',$59F2.W	; "File"
	bne	PatchUnknown

	move.l	#VER_ITALIAN,(A0)

	; *** load routine - italian

	PATCHUSRJMP	$3BB86,ReadSectors2

	; *** copy protection - italian

	move.l	#$42404E75,$1970C

	; *** kb interrupt - italian

	PATCHUSRJSR	$1FD4C,KbInt

	; *** memory patch - italian

	PATCHUSRJMP	$1F9C4,RelocateItalian

	; *** HD saves - italian

	; *** removes insert disk requester for load/save - italian

	move.l	#$4E714E71,$1FF5A	; SAVE
	move.l	#$4E714E71,$20090	; LOAD

	; *** load and save - italian

	PATCHUSRJMP	$19C2C,SaveGameHD
	PATCHUSRJMP	$19C56,LoadGameHD
	PATCHUSRJMP	$3BC0A,SaveGameDir

	; *** prevents floppy formatting

	move.l	#$7E004E75,$3BC9C

	; *** removes a $BFD100 access routine

	move.l	#$70004E75,$3BD42

	; *** copies the decrunch1 routine in fast memory - english

	lea	START_DECRUNCH1_ITALIAN,A0
	lea	END_DECRUNCH1_ITALIAN,A2

	bsr	RelocDecrunch1

	PATCHUSRJMP	START_DECRUNCH1_ITALIAN,FastDecrunch1


	; *** copies the decrunch2 routine in fast memory - english

	lea	START_DECRUNCH2_ITALIAN,A0
	lea	END_DECRUNCH2_ITALIAN,A2

	bsr	RelocDecrunch2

	PATCHUSRJMP	START_DECRUNCH2_ITALIAN,FastDecrunch2

	bra	PatchStart1
	
PatchUnknown:
	lea	WrongVer(pc),A0
	IFD	WHDLOADSLAVE
	WRONG_VERSION
	ELSE
	JSRGEN	SetExitRoutine
	ENDC
	JSRGEN	InGameExit

; works for all versions

PatchAccessFault:
	STORE_REGS
	; access fault #1 - programming error

	lea	$1E000,a0
	lea	$24000,a1
	lea	.afpattern_1(pc),a2
	moveq	#8,d0
	bsr	.hexsearch
	cmp.l	#0,a0
	beq.b	.skip1
	move.b	#$d6,2(a0)	; add.l d1,a3 -> add.w d1,a3
.skip1
	; access fault #2 - jump table error

	lea	$17000,a0
	lea	$1A000,a1
	lea	.afpattern_2(pc),a2
	moveq	#8,d0
	bsr	.hexsearch
	cmp.l	#0,a0
	beq.b	.skip2
	PATCHUSRJSR	(A0),_avoid_af2
.skip2

	RESTORE_REGS
	rts

.afpattern_1:
	dc.l	$2653D7C1,$D6C04E75
.afpattern_2:
	dc.l	$246D0002,$301AE548
.hexsearch:
	JSRGEN	HexSearch
	rts

_avoid_af2:
	move.l	(2,a5),a2
	cmp.l	#$4000,a2
	bcs.b	.avoid
	cmp.l	#$80000,a2
	bcc.b	.avoid
	move.w	(a2)+,d0
	rts

.avoid
	moveq	#0,d0
	rts

; **** GERMAN version
	
PatchGerman1:
	move.l	#VER_GERMAN,(A0)

	; *** load routine

	PATCHUSRJMP	$3DA1E,ReadSectors2

	; *** copy protection

	move.w	#$604A,$198E0

	; *** kb interrupt

	PATCHUSRJSR	$1FF28,KbInt

	; *** $BFD100 routine - german

	move.l	#$70FF4E75,$3DBDA

	; *** memory patch - german

	PATCHUSRJMP	$1FBA0,RelocateGerman

	; *** HD saves

	PATCHUSRJMP	$19E00,SaveGameHD
	PATCHUSRJMP	$19E2A,LoadGameHD
	PATCHUSRJMP	$3DAA2,SaveGameDir

	; *** removes insert disk requester for load/save - german

	move.l	#$4E714E71,$20136
	move.l	#$4E714E71,$2026C

	; *** prevents floppy formatting

	move.l	#$7E004E75,$3DB34

	; *** copies the decrunch1 routine in fast memory

	lea	START_DECRUNCH1_GERMAN,A0
	lea	END_DECRUNCH1_GERMAN,A2

	bsr	RelocDecrunch1

	PATCHUSRJMP	START_DECRUNCH1_GERMAN,FastDecrunch1

	; *** copies the decrunch2 routine in fast memory

	lea	START_DECRUNCH2_GERMAN,A0
	lea	END_DECRUNCH2_GERMAN,A2

	bsr	RelocDecrunch2

	PATCHUSRJMP	START_DECRUNCH2_GERMAN,FastDecrunch2

;	move.w	#$4EF9,$19E00
;	move.l	#CopyDisk,$19E02	
	

.nocopydisk
	bra	PatchStart1

RelocDecrunch1:
	lea	FastDecrunch1(pc),A1
.decmv
	move.w	(a0)+,(a1)+
	cmp.l	A0,A2
	bne	.decmv
	rts

RelocDecrunch2:
	lea	FastDecrunch2(pc),A1
.decmv
	move.w	(a0)+,(a1)+
	cmp.l	A0,A2
	bne	.decmv
	rts

KbInt:
	lea	$4414.W,A1
	move.b	D0,D1
	IFND	WHDLOADSLAVE
	cmp.b	#$59,D0
	ELSE
	cmp.b	_whdinit_base+ws_keyexit(pc),D0
	ENDC
	bne	.noquit
	JSRGEN	InGameExit
.noquit
	rts

ReadSectors2:
	tst.w	D1
	bne	.noboot
	cmp.w	#1,D2
	bne	.noboot

	bra	LoadGameDir
.noboot
;	tst.l	noosswap
	bra	.hdload

	; ** try to figure out if this is a game load

	cmp.w	#$8C,D2		; length
	beq	.test2
	cmp.w	#$8B,D2		; length (for french version)
	bne	.hdload
.test2
	cmp.l	#$4000,A0	; buffer
	bne	.hdload

	; *** we can reasonably assume that it's a savegame
	; *** read the savegame data from floppy

	bra	BypassLoad

.hdload
	move.l	D0,-(sp)
	moveq.l	#0,D0
	move.w	$44DA.W,D0		; required disk
	subq	#1,D0			; 1,2,3,4
	bsr	ReadSectors
	move.l	(sp)+,D0
	rts

ReadSectors:
	move.l	D3,D7
	moveq	#0,D3
	JSRGEN	ReadRobSectors
	move.l	D7,D3
	moveq.l	#0,D7
	rts

LoadGameHD:
	movem.l	D1-D7/A0-A6,-(sp)
	
	add.b	#'1',D0
	lea	savenum(pc),A0
	move.b	D0,(A0)
	lea	savename(pc),A0
	lea	$4000.W,A1	; buffer
	moveq.l	#0,D0
	move.l	#SAVE_LEN,D1
	JSRGEN	ReadUserFileHD

	movem.l	(sp)+,D1-D7/A0-A6
	rts


SaveGameHD:
	movem.l	D1-D7/A0-A6,-(sp)
	
	add.b	#'1',D0
	lea	savenum(pc),A0
	move.b	D0,(A0)
	lea	savename(pc),A0
	lea	$4000.W,A1	; buffer
	moveq.l	#0,D0
	move.l	#SAVE_LEN,D1
	JSRGEN	WriteUserFileHD

	movem.l	(sp)+,D1-D7/A0-A6
	rts


LoadGameDir:
	; *** load the game directory from HD

	movem.l	D0-D6/A0-A6,-(sp)

	move.l	A0,A1			; buffer
	lea	dirname(pc),A0
	moveq.l	#0,D0
	move.l	#$200,D1
	JSRGEN	ReadUserFileHD
	tst.l	D0
	bne	.error

	moveq.l	#0,D7
.exit
	movem.l	(sp)+,D0-D6/A0-A6
	rts
.error
	moveq	#-1,D7
	bra	.exit

BypassLoad:
	JSRGEN	WaitMouse
	illegal

BypassLoadGerman:
	JSR	$3DC2E			; resumes floppy access
	JMP	$3DA26

BypassLoadFrench:
	JSR	$3CDC4			; resumes floppy access
	JMP	$3CC40

BypassLoadEnglish:
	illegal
	JSR	$3CDC4			; resumes floppy access
	JMP	$3CC4A


SaveGameDir:
	moveq.l	#0,D7

	tst.w	D1
	bne	.exit
	cmp.w	#1,D2
	bne	.exit

	; *** save the game directory to HD

	movem.l	D0-D6/A0-A6,-(sp)

	move.l	A0,A1
	lea	dirname(pc),A0
	moveq.l	#0,D0
	move.l	#$200,D1
	JSRGEN	WriteUserFileHD
	tst.l	D0
	bne	.error

.exit
	movem.l	(sp)+,D0-D6/A0-A6
	rts
.error
	moveq	#-1,D7
	bra	.exit

BypassSave:
	JSRGEN	InGameExit


BypassSaveGerman:
	JSRGEN	InGameExit

	JSR	$3DC2E			; resumes floppy access
	JMP	$3DAAA

BypassSaveFrench:
	JSRGEN	InGameExit

	JSR	$3CDC4			; resumes floppy access
	JMP	$3CC4A

BypassSaveEnglish:
	JSRGEN	WaitMouse
	JSRGEN	InGameExit
	illegal
	JSR	$3CDC4			; resumes floppy access
	JMP	$3CC4A

RelocateItalian:
	lea	$17406,a0
	bra	RelocateCommon

RelocateFrench:
	LEA	$1740E,A0
	bra	RelocateCommon

RelocateGerman:
	LEA	$1747C,A0
	bra	RelocateCommon

RelocateEnglish:
	LEA	$17430,A0
	bra	RelocateCommon

RelocateEnglish2:
	LEA	$173F6,A0
	bra	RelocateCommon
	
RelocateCommon:
	move.l	ExtBase(pc),D0
	sub.l	#$C00000,D0		; game designed for $C00000 addresses
	MOVE	#$0014,D7
LAB_0000:
	ADD.L	D0,(A0)+
	DBF	D7,LAB_0000

	move.l	ExtBase(pc),D0
	RTS


; *** part common to all versions (fortunately !!!)

installboot:
	lea	boot(pc),A0
	lea	$70000,A1

	JSRGEN	RNCDecrunch

	lea	$70000,A1

	; *** load

	PATCHUSRJMP	$3D4(a1),ReadSectors

	; *** after load

	PATCHUSRJMP	$29C(A1),PatchLoader1

	; *** remove a cacr remove routine

	move.l	#$4E714E71,$DCC(A1)

	; *** remove sort of speed/pal/ntsc test

	move.w	#$4E71,$12E(A1)

	rts

MemErr:
	Mac_printf	"** Not enough memory to run the game!"
	JMPABS	CloseAll


WrongVer:
	IFND	WHDLOADSLAVE
	Mac_printf	"** Your version is not supported! Contact author"
	Mac_printf	"   Hit RETURN!"
	JSRABS	WaitReturn
	rts
	ELSE
	WRONG_VERSION
	ENDC

ExtBase:
	dc.l	0

version:
	dc.l	0

savename:
	dc.b	"luresave."
savenum:
	dc.b	"0",0
dirname
	dc.b	"luresave.dir",0

	cnop	0,4
FastDecrunch1:
	blk.b	END_DECRUNCH1_GERMAN-START_DECRUNCH1_GERMAN+16,0

FastDecrunch2:
	blk.b	END_DECRUNCH2_FRENCH-START_DECRUNCH2_FRENCH+16,0

	cnop	0,4
buttonwait:
	dc.l	0
boot:
	incbin	"lureboot.rnc"
